VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmProd 
   Caption         =   "Entradas y Edicin de Productos"
   ClientHeight    =   6075
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   13815
   OleObjectBlob   =   "frmProd.frx":0000
   StartUpPosition =   1  'Centrar en propietario
End
Attribute VB_Name = "frmProd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Option Explicit
Public pasar 'Por DAM Para que no busque sin que seleccione el criterio
Dim ws As Worksheet 'Variable para hojas para poder ejecutar macros del formulario en la hoja Activa, en ves de Sheets("hoja")

Private Sub cboHojas_Change()
    Dim Hoja As String
    Dim hojaTrabajo As Worksheet
    Dim hojaRow As Range
    Application.ScreenUpdating = False
    Hoja = cboHojas.Text

    Set hojaTrabajo = Worksheets(Hoja)
    hojaTrabajo.Activate

    UF = Range("A2:A" & Rows.Count).End(xlDown).Row
    UC = Cells(1, Columns.Count).End(xlToLeft).Column
    Set hojaRow = Range(Cells(2, 1), Cells(UF, UC))
    lista.RowSource = ""
    lista.RowSource = hojaRow.Address
    
    Call BuscaCambio 'probar traendo este Call del Initialize para aqui, funciona mejor evitando el error al editar o ingresar nuevo
    Call contador(Me)
    Call Limpar(Me)
    FiltrarPor.SetFocus
    Application.ScreenUpdating = True
End Sub

Private Sub cbtEliminar_Click()
Set ws = ActiveSheet 'Variable para hojas para poder ejecutar macros del formulario en la hoja Activa
'Por Dante: http://www.todoexpertos.com/preguntas/7ydl7ju66hkoens5/correccion-en-macro-excel-por-que-no-elimina-la-fila-seleccionada-en-el-listbox-y-si-otra?nid=gcqp5uuggnw63hkqi8qa5suihctmdgepgru9hgulabr3&utm_source=todoexpertos&utm_medium=EmailNotification&utm_campaign=AskerQuestion_ExpertMessageAdded
    Dim i As Long
    Dim d As Variant
    Application.ScreenUpdating = False
    If lista.ListIndex = -1 Then
        MsgBox "Selecciona un registro de la lista"
        Exit Sub
    End If
    d = lista.List(lista.ListIndex, 1) '1 columna B
    c = lista.List(lista.ListIndex, 0) '0 columna A
    If MsgBox("Confirma ELIMINAR el codigo " & c & " del registro " & d & "?", _
        vbYesNo + vbQuestion, "ELIMINACIN") = vbNo Then Exit Sub
    '
    With ws
        codigo = lista.List(lista.ListIndex, 0)
        Set b = .Columns("A").Find(codigo, lookat:=xlWhole)
        If Not b Is Nothing Then
            'i = lista.ListIndex + 2
            i = b.Row
            .Range("a" & i).EntireRow.Delete
            Call BuscaCambio
'Call actualizar_lista
        End If
    End With
    Call contador(Me)
    Call Limpar(Me)
    Application.ScreenUpdating = True
End Sub

Private Sub cbtCopia_Nuevo_Click() 'Respalda datos del listBox a nuevo libro .xlsx
'Por.Dante Amor
    Application.ScreenUpdating = False
    Set hc = HojaProd 'Se establece la variable hc como la hoja origen
    Set l1 = Workbooks.Add 'Se crea un nuevo libro y a la vez se establece el nuevo libro en la variable l1
    Set h1 = l1.ActiveSheet 'Se establece la nueva hoja del libro nuevo en la variable h1
    '
    c = lista.ColumnCount 'Cuenta la cantidad columnas del ListBox
    F = lista.ListCount 'cuenta el nmero de lineas del ListBox
    hc.Rows(1).Copy h1.Range("A1") 'Se copia la fila 1 de la hoja origen a la nueva hoja empezando en la celda A1
    hc.Columns("A:G").Copy ''Copia las columnas. Para poner el mismo ancho de columnas:
    h1.Range("A1").PasteSpecial Paste:=xlFormats 'Las pega pero con formato especial slo formatos
    '
    h1.Range(h1.Cells(2, 1), h1.Cells(F + 1, c - 2)) = lista.List 'resta 2 columnas
    '
'Para poner el formato de fecha utilizo la siguiente instruccin para cada fecha que tiene almacenada en el listbox
    For i = 0 To lista.ListCount - 1
        h1.Cells(i + 2, "G") = Format(lista.List(i, 6), "mm/dd/yyyy")
    Next
    '
'Las fechas estn en la columna 6 del listbox y se pasan a la columna "G"
    Application.DisplayAlerts = False 'Para que solo pregunte 1 vez si  quiero reemplazar el existente
    anular = False
    With Application.FileDialog(msoFileDialogSaveAs)
        .Title = "Exportar a Archivo"
        .AllowMultiSelect = False
        .FilterIndex = 1
        If .Show Then
            march = .SelectedItems(1)
            Range("A2").Select 'quitar la seleccion
            h1.SaveAs Filename:=march, FileFormat:=xlOpenXMLWorkbook, CreateBackup:=False
        Else
            anular = True
        End If
        Application.CutCopyMode = False 'Cancela el modo Cortar o Copiar y elimina el borde mvil.
    End With
    l1.Close 'Cierra el nuevo libro
    Application.ScreenUpdating = True
    Application.DisplayAlerts = True
    If anular Then
        MsgBox "Cancelado el proceso de Respaldo", 64, "Respaldar datos"
    Else
        MsgBox "Datos respaldados en Nuevo Libro", 64, "Respaldar datos"
    End If
    Unload Me
    Inicio.Select
End Sub

Private Sub lista_Click()
    Dim v   As Variant
    Dim txt As MSForms.TextBox
    Dim i%
    Set ws = ActiveSheet
    Dim z As Integer
    txtCod.Enabled = False
    txtProve.Enabled = False
    
    With ws
'Si encuentra en A el dato seleccionado en ListBox, llena los TextBox
        Set b = .Range("A2:A25000").Find(lista.Value, lookat:=xlWhole, LookIn:=xlValues) '.Row
        If Not b Is Nothing Then
            v = Array(txtCod, txtProd, txtProve, txtFactu, DTPicker1, txtUbic, txtObser)
            For i = 0 To UBound(v)
                If i = 4 Then
                    DTPicker1 = .Cells(b.Row, i + 1)
                Else
                    Set txt = v(i)
                    txt.Text = .Cells(b.Row, i + 1)
                    Set txt = Nothing
                End If
            Next
        End If
    End With
    

  'If txtUbic = "" Then txtUbic = 0
  txtUbic = Format(txtUbic, "Currency") 'Para formato moneda

Rem Para Marcar selecionada la linea del articulo selcionado en el ListBox
    Celda = lista.List(lista.ListIndex)
    Cells.Find(what:=Celda).Activate
    Range(Cells(Selection.Row, 1), Cells(Selection.Row, 7)).Select
    'Buscar.Enabled = False
End Sub

Private Sub txtCod_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
KeyAscii = Asc(LCase(Chr(KeyAscii)))
If Len(txtCod) = 10 Then KeyAscii = 0: MsgBox "MAX permitido en Cod Producto, 10 dgitos": Exit Sub
End Sub

Private Sub txtFactu_Change()
'txtFactu = Format(txtFactu, "00000000")
End Sub

Private Sub txtObser_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
If Len(txtObser) = 50 Then KeyAscii = 0: MsgBox "MAX permitido en Cod Producto, 50 dgitos": Exit Sub
End Sub

Private Sub txtUbic_Exit(ByVal Cancel As MSForms.ReturnBoolean)
  'If txtUbic = "" Then txtUbic = 0
  txtUbic = Format(txtUbic, "Currency") 'Para formato moneda
End Sub

Private Sub UserForm_Initialize()
    With cboHojas
        .List = Array("PRODUCTOS", "CAT", "JOHN DEERE", "SILVERADO", "INTERNACIONAL")
    End With
    DTPicker1 = (Date)
    FiltrarPor.List = Array("COD PRODUCTO", "NOMBRE PRODUCTO", "UBICACION")

    '''Call BuscaCambio  'probar cambiado de aqui para el evento change del desplegable funciona mejor evitando el error al editar o ingresar nuevo
End Sub

Private Sub cbtEdCli_Click() 'Valida Edicion
    On Error Resume Next
    Dim fila As Integer
    Set ws = ActiveSheet
    With ws
       fila = .Range("A2:A25000").Find(txtCod, lookat:=xlWhole).Row
       If Err.Number = 91 Then
          fila = .Range("B" & .Rows.Count).End(xlUp)(2).Row
        Call ingresar_EdCli(fila)
        Exit Sub
    End If
        Call ingresar_EdCli(fila)
    End With
    'Buscar.Enabled = False
End Sub

Sub ingresar_EdCli(fila As Integer, Optional OrdenarPor As String = "B")
    Dim strfila$
    Set ws = ActiveSheet
    Application.ScreenUpdating = False
    With ws
        strfila$ = .Range("A2:A25000").Find(txtCod, lookat:=xlWhole).Row
        '.Range("A" + strfila$) = txtCod 'Cod Producto No se edita
        .Range("B" + strfila$) = txtProd 'Nombre producto
        '.Range("C" + strfila$) = txtProve 'Cantidad no se edita
        .Range("D" + strfila$) = txtFactu 'Ubicacion
        .Range("E" + strfila$) = Format(DTPicker1, "mm/dd/yyyy") 'Fecha
        .Range("F" + strfila$) = CDbl(txtUbic.Value) 'Valor unitario
        .Range("G" + strfila$) = txtObser 'Observaciones
        .Range("A2:G" & fila).Sort key1:=.Range(OrdenarPor & fila) 'ordena datos
    End With
    
'carga ListBox
    Call BuscaCambio
    Call actualizar_lista
    Application.ScreenUpdating = True
'limpiar controles
    Call Limpar(Me)
    Buscar.SetFocus
End Sub

Private Sub actualizar_lista()
    lista.RowSource = ""
    lista.RowSource = "Filtro!A2:G" & Sheets("Filtro").Range("A" & Rows.Count).End(xlUp).Row
    Buscar.SetFocus
End Sub

Private Sub cbtLimpia_Click() 'TextBox nombre personalisado
    Call Limpar(Me)
    txtCod.Enabled = True
    txtProve.Enabled = True
    
'DEselecciona con la propiedad MultiSelected del ListBox en 0
    lista.ListIndex = -1 'deselecciona solo siendo MultiSelected en 0 una sola linea
'    Buscar.SetFocus
End Sub

Private Sub FiltrarPor_Change()
    Buscar.Enabled = True
    buscar_Change
    Buscar.Value = ""
    Buscar.SetFocus
End Sub

Sub buscar_Change()
    Set ws = ActiveSheet
    Application.ScreenUpdating = False
    If pasar = 1 Then 'Obliga a buscar seleccionando criterio

    Else
        If FiltrarPor = "" Then
    MsgBox "Seleccione el critrio a Buscar"

            pasar = 1
                Buscar = ""
            Exit Sub
        End If
    End If
    pasar = 0 'Obliga a buscar seleccionando criterio

    lista.RowSource = ""
    Sheets("Filtro").Cells.Clear
    ws.Range("A:G").Copy Sheets("Filtro").Range("A1")
    Sheets("Filtro").Range("A2:G2").Insert Shift:=xlDown
    Sheets("Filtro").Range("B2:G2") = ""
    Sheets("Filtro").Range("A2") = Buscar 'Buscar por CODIGO
    
    If FiltrarPor.ListIndex = 1 Then 'Buscar por NOMBRE
       Sheets("Filtro").Range("A2") = ""
       Sheets("Filtro").Range("B2") = Buscar
    End If
    
    If FiltrarPor.ListIndex = 2 Then 'Buscar por Ubicacin
       Sheets("Filtro").Range("A2") = ""
       Sheets("Filtro").Range("B2") = ""
       Sheets("Filtro").Range("D2") = Buscar
    End If
    
    'If FiltrarPor.ListIndex = 3 Then 'Buscar por proveedor
    '   Sheets("Filtro").Range("A2") = ""
    '   Sheets("Filtro").Range("B2") = ""
    '   Sheets("Filtro").Range("D2") = ""
    '   Sheets("Filtro").Range("E2") = Buscar
    'End If
    
    Sheets("Filtro").Range("A1:G25000").AdvancedFilter _
                     Action:=xlFilterCopy, _
                     CriteriaRange:=Sheets("Filtro").Range("A1:G2"), _
                     CopyToRange:=Sheets("Filtro").Range("H1:N25000")
    Sheets("Filtro").Rows(2).Delete
    fila = Sheets("Filtro").Range("H" & Rows.Count).End(xlUp).Row
    If fila > 1 Then lista.RowSource = "Filtro!H2:N" & fila
    Call contador(Me)

    Application.ScreenUpdating = True
End Sub

Private Sub cbtNueClien_Click()
    On Error Resume Next
    Dim fila As Integer
    Set ws = ActiveSheet
    If cboHojas.Value = "" Then
        MsgBox "NO HA SELECCIONADO HOJA"
        Exit Sub
    Else
    
'Viene de la Function valida(wtext As MSForms.Control, num)
    If MINCaracter(txtCod, "Cod/Producto", 10) = False Then Exit Sub ''AQUI 10 DIGITOS MINIMO
''''''''''''''
    If Application.CountIf(ActiveSheet.Range("B2:B50000"), txtProd.Value) Then 'Busca en la columna A si existe el contacto
Rem Si existe la rutina llega solo al If mensage. si no existe, brinca despus de Else para insertar los datos.
        Mensage = MsgBox("El producto " & txtProd.Text & " ya existe." & vbCrLf & vbCrLf & _
                "Puede escribir nuevo nombre y seguir, o en otro proceso editar datos", vbInformation + vbOKOnly, "CONTACTO EXISTENTE")
        txtProd.Text = "" 'Si te d mensage, Limpia el TextBox
        If Mensage = vbOK Then Exit Sub 'Del mensage presionas OK y hasta el Exit Sub llega la rutina
    Else
''''
'Inserta datos de nuevo cliente
    With ws
       fila = .Range("A2:A25000").Find(txtCod, lookat:=xlWhole).Row
       If Err.Number = 91 Then
          fila = .Range("b" & .Rows.Count).End(xlUp)(2).Row
          Call ingresar_datos(fila)
          Exit Sub
       End If
       Call ingresar_datos(fila)
    End With
    End If
    End If
    
    Buscar.Enabled = False
End Sub

'Inserta y luego ordena alfabeticamente de B hasta G tomando columna B
Sub ingresar_datos(fila As Integer, Optional OrdenarPor As String = "B") 'Ordena por la columna B
    Set ws = ActiveSheet
    Application.ScreenUpdating = False
    With ws
        .Cells(fila, 1) = txtCod
        .Cells(fila, 2) = txtProd
        .Cells(fila, 3) = txtProve
        .Cells(fila, 4) = txtFactu
        .Cells(fila, 5) = Format(DTPicker1, "mm/dd/yyyy") 'DTPicker1 en ves de txtFFact
'        .Cells(fila, 5) = NumberFormat = "dd/mm/yyyy" 'dar formato a la celda
        .Cells(fila, 6) = CDbl(txtUbic.Value)
        .Cells(fila, 7) = txtObser
        .Range("A2:G" & fila).Sort key1:=.Range(OrdenarPor & fila)
    End With
       
    Application.ScreenUpdating = True
'limpiar controles
    Call Limpar(Me)
'carga ListBox
    Call BuscaCambio
    Call actualizar_lista
    Call contador(Me)
    Range("A2").Select
    txtCod.SetFocus
End Sub

Sub BuscaCambio() 'Por DAM Busqueda obligando a seleccionar el criterio por el que buscar
    frmProd.pasar = 1
    frmProd.buscar_Change
    frmProd.pasar = 0
End Sub

Function MINCaracter(wtext As MSForms.Control, Texto, cantidad)
'Por.Dante Amor 'Valida contenido de un textbox
    If Len(wtext) <> cantidad Then
        MsgBox "El " & Texto & " no contiene la cantidad de dgitos necesarios", 64, ""
        wtext.SetFocus
        MINCaracter = False
    Else
        MINCaracter = True
    End If
End Function

Private Sub cbtCerrar_Click()
    Unload Me
     Sheets("Filtro").Cells.Clear
         Inicio.Select
End Sub

Sub Limpar_NO_uso() 'Limpiar controles TextBox
    Dim Control As Object
    For Each Control In Controls
        If TypeName(Control) = "TextBox" Then Control.Value = ""
    Next
    txtCod.Enabled = True
    txtProve.Enabled = True
    MsgBox ("Cajas de texto limpios para nuevo uso"), vbInformation, "Limpiesa"
End Sub
